=== test/unit/rich_value/Makefile ===
###############################################################################
#
# Makefile for libxlsxwriter library.
#
# Copyright 2014-2015, John McNamara, jmcnamara@cpan.org
#

include ../Makefile.unit
