=== debian/changelog ===
libxlsxwriter (1.2.3-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Wed, 13 Aug 2025 15:18:20 -0400

libxlsxwriter (1.2.3-1~exp1) experimental; urgency=medium

  * New upstream release.
  * SONAME bump: libxlsxwriter8 => libxlsxwriter10.
  * debian/libxlsxwriter10.symbols: Updated.

 -- Boyuan Yang <byang@debian.org>  Tue, 12 Aug 2025 13:34:33 -0400

libxlsxwriter (1.2.1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Sun, 02 Mar 2025 22:22:20 -0500

libxlsxwriter (1.2.1-1~exp2) experimental; urgency=medium

  * New upstream release.
  * debian/control: Add explicit binary dep libssl-dev.

 -- Boyuan Yang <byang@debian.org>  Sun, 02 Mar 2025 14:16:35 -0500
