=== debian/control ===
Source: libxlsxwriter
Section: libs
Priority: optional
Maintainer: Ma Aiguo <imaiguo@gmail.com>
Uploaders:
 Boyuan Yang <byang@debian.org>,
 Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>,
Build-Depends: dpkg-dev (>= 1.22.5),
 cmake,
 debhelper-compat (= 13),
 libminizip-dev,
 libssl-dev,
 pkgconf,
 python3-dev,
 python3-pytest <!nocheck>,
 zlib1g-dev,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/jmcnamara/libxlsxwriter
Vcs-Git: https://salsa.debian.org/debian/libxlsxwriter.git
Vcs-Browser: https://salsa.debian.org/debian/libxlsxwriter
Description: Library for XLSX
 Libxlsxwriter is a C library that can be used
 to write text, numbers, formulas and hyperlinks to multiple
 worksheets in an Excel 2007+ XLSX file.

Package: libxlsxwriter-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libssl-dev,
 libxlsxwriter10 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} -- development library of xlsxwriter
 ${source:Extended-Description}
 .
 This package contains the header file and development library of
 xlsxwriter.

Package: libxlsxwriter10
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} -- runtime library
 ${source:Extended-Description}
 .
 This package contains the runtime and shared library of xlsxwriter.
