=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CXXFLAGS += $(CPPFLAGS)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DBUILD_SHARED_LIBS=ON \
	    -DUSE_SYSTEM_MINIZIP=ON \
	    -DUSE_OPENSSL_MD5=ON \
	    -DBUILD_TESTS=ON \
	    -DBUILD_EXAMPLES=ON \
	    $(EXTRA_CONFIG_FLAGS)
