## libxlsxwriter 1.2.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-#  :copyright: 2014-2025. John McNamara, Alex Huszagh.
+#  :copyright: 2014-2026. John McNamara, Alex Huszagh.
 #  :license: SPDX-License-Identifier: BSD-2-Clause
 
 # CMake file for libxlsxwriter
@@ -354,8 +354,7 @@
 # If not using the system minizip, add the vendored minizip source files.
 if(NOT USE_SYSTEM_MINIZIP)
     list(
-        APPEND
-        LXW_SOURCES
+        APPEND LXW_SOURCES
         third_party/minizip/ioapi.c
         third_party/minizip/zip.c
     )
