=== examples/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #
 # Makefile for libxlsxwriter examples.
 #
-# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org
+# Copyright 2014-2026, John McNamara, jmcnamara@cpan.org
 #
 
 # Keep the output quiet by default.
