=== test/unit/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Makefile for libxlsxwriter library.
 #
 # SPDX-License-Identifier: BSD-2-Clause
-# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org.
+# Copyright 2014-2026, John McNamara, jmcnamara@cpan.org.
 #
 
 # Keep the output quiet by default.
