=== debian/changelog ===
libxlsxwriter (1.2.4-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Fri, 16 Jan 2026 13:51:21 -0500

libxlsxwriter (1.2.4-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/control: Bump Standards-Version to 4.7.3.
  * debian: Bump SONAME from 10 to 11.
  * debian/libxlsxwriter11.symbols: Updated.

 -- Boyuan Yang <byang@debian.org>  Tue, 13 Jan 2026 11:39:19 -0500
