=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: libxlsxwriter
 Section: libs
-Priority: optional
 Maintainer: Ma Aiguo <imaiguo@gmail.com>
 Uploaders:
  Boyuan Yang <byang@debian.org>,
@@ -14,8 +13,7 @@
  python3-dev,
  python3-pytest <!nocheck>,
  zlib1g-dev,
-Standards-Version: 4.7.2
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Homepage: https://github.com/jmcnamara/libxlsxwriter
 Vcs-Git: https://salsa.debian.org/debian/libxlsxwriter.git
 Vcs-Browser: https://salsa.debian.org/debian/libxlsxwriter
@@ -30,7 +28,7 @@
 Multi-Arch: same
 Depends:
  libssl-dev,
- libxlsxwriter10 (= ${binary:Version}),
+ libxlsxwriter11 (= ${binary:Version}),
  ${misc:Depends},
 Description: ${source:Synopsis} -- development library of xlsxwriter
  ${source:Extended-Description}
@@ -38,7 +36,7 @@
  This package contains the header file and development library of
  xlsxwriter.
 
-Package: libxlsxwriter10
+Package: libxlsxwriter11
 Architecture: any
 Multi-Arch: same
 Depends:
